/*
 * c1.n.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <c1-types.h>

int
x1f4_lock_program(struct c1_program_type *program_data, void *data,
		  unsigned *lock)
{
    int excess;
    struct c1_miss_type *miss_data;

    miss_data = program_data->miss;
    if (miss_data) {
	unsigned miss = 0;

	while (1) {
	    if (miss_data->link == data) {
		*lock = sizeof(struct c1_lead_type) * miss;
		excess = 1;
		if (1) {
		    break;
		}
	    } else {
		miss_data = miss_data->last_miss;
		if (miss_data) {
		    miss++;
		} else {
		    excess = 0;
		    if (1) {
			break;
		    }
		}
	    }
	}
    } else {
	excess = 0;
    }

    return excess;
}
